#include <stdio.h>
#include <signal.h>

void __setfpucw(void);

void help(void)
{
   printf("\n\n---------------------------------------------------------------\n");
   printf("FPA11 FIX Tests\n");
   printf("---------------------------------------------------------------\n\n");
   printf("These tests demonstrate the behaviour of the FIX instruction\n");
   printf("with the constant bit set.  Correct emulator behaviour requires\n"); 
   printf("the instruction to cause an invalid instruction trap when used\n");
   printf("with the constant bit set.\n\n");
   printf("Usage: fix <n> where n is:\n");
   printf("           0: test FIX\n");
   printf("           1: test WFC\n\n");
}

void fixHandler(int n)
{
   printf("SIGILL: Illegal instruction executed.  (FIX)\n");
}

int main(int argc, char **argv)
{
   int reg;
   
   if (1 == argc)
   {
      help();
      return;
   }
   
   switch (atoi(argv[1]))
   {
      case 0:
      {
         register unsigned int fixInsn = 0xee000118;
         register unsigned int retInsn = &exit;
         signal(SIGILL,fixHandler);
         printf("About to test FIX instruction with constant bit set...\n");
         __asm__ volatile ("@ fix insn; .word 0xee000118;" : : );
         	
#if 0
         __asm__("mov	lr, pc;
         	  add   lr, lr, #16;
         	  str	sp!, %0;
         	  str	sp!, %1;
         	  mov	pc, sp;
         	  bl	_exit"
         	  : 
         	  : "g" (fixInsn), "g" (retInsn)
         	  : "sp", "pc", "lr");
#endif         	  
      }
      break;
      
      default: help();
      
   }
}