#include <stdio.h>
#include <signal.h>

void __setfpucw(void);

void help(void)
{
   printf("\n\n---------------------------------------------------------------\n");
   printf("FPA11 WFC/RFC Tests\n");
   printf("---------------------------------------------------------------\n\n");
   printf("These tests demonstrate whether the WFC/RFC instructions are\n");
   printf("available from user mode.  Correct emulator behaviour requires\n"); 
   printf("the instructions to cause an invalid instruction trap when used\n");
   printf("from user code.\n\n");
   printf("Usage: wfcrfc <n> where n is:\n");
   printf("           0: test RFC\n");
   printf("           1: test WFC\n\n");
}

void rfcHandler(int n)
{
   printf("SIGILL: Illegal instruction executed.  (RFC)\n");
}

void wfcHandler(int n)
{
   printf("SIGILL: Illegal instruction executed.  (WFC)\n");
}

int main(int argc, char **argv)
{
   int reg;
   
   if (1 == argc)
   {
      help();
      return;
   }
   
   switch (atoi(argv[1]))
   {
      case 0:
      {
         signal(SIGILL,rfcHandler);
         printf("About to test RFC instruction...\n");
         __asm__("mov %0, #0; rfc %0;" : : "g" (reg));
      }
      break;
      
      case 1:
      {
         signal(SIGILL,wfcHandler);
         printf("About to test WFC instruction...\n");
         __asm__("mov %0, #0; wfc %0;" : : "g" (reg));
      }
      break;
      
      default: help();
   }
}